您的位置:首页 > 其它

[LeetCode] Two Sum

2015-08-18 12:47 309 查看
Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

这道排在第一位置的题我却现在才做,别的不说了。这个用HashMap即可轻松解决。

不过注意的是,因为不能return 0.但是直接用map.get()method的话是有可能产生0的,所以return的i都要+1。

代码如下。~

public class Solution {
public int[] twoSum(int[] nums, int target) {
HashMap<Integer,Integer> result=new HashMap<>();
for(int i=0;i<nums.length;i++){
if(result.containsKey(target-nums[i])){
return new int[]{result.get(target-nums[i])+1,i+1};
}else{
result.put(nums[i],i);
}
}
return null;
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: